from setuptools import setup, find_packages  # Always prefer setuptools over distutils
from codecs import open  # To use a consistent encoding
from os import path
import subprocess
from setuptools.command.install import install
import re
import ast

_version_re = re.compile(r'__version__\s+=\s+(.*)')
version = str(ast.literal_eval(
    _version_re.search(
        open('salar/__init__.py').read()
    ).group(1)
))
here = path.abspath(path.dirname(__file__))


class MyInstall(install):
    def run(self):
        print("-- installing... (powered by salar) --")
        install.run(self)

setup(
        name = 'salar',
        version=version,
        description='Web framework and Tookit for generating command line interfaces',
        long_description='\nREADME: https://github.com/qorzj/salar',
        url='https://github.com/qorzj/salar',
        author='qorzj',
        author_email='inull@qq.com',
        license='MIT',
        platforms=['any'],

        classifiers=[
            ],
        keywords='salar web cli',
        packages = ['salar', 'salar.plugin'],
        install_requires=[],

        cmdclass={'install': MyInstall},
        entry_points={
            'console_scripts': [
                'salar = salar.run:main',
                ],
            },
    )
